VERSION 2.00
Begin Form frmMain 
   Caption         =   "Tutorial 7 -- The Sprite Engine."
   ClientHeight    =   3930
   ClientLeft      =   615
   ClientTop       =   1500
   ClientWidth     =   7365
   ClipControls    =   0   'False
   Height          =   4335
   Icon            =   EG2.FRX:0000
   Left            =   555
   LinkTopic       =   "Form1"
   ScaleHeight     =   3930
   ScaleWidth      =   7365
   Top             =   1155
   Width           =   7485
   Begin Timer tmrGameLoop 
      Interval        =   20
      Left            =   1260
      Top             =   5280
   End
   Begin PictureBox picSpr 
      Height          =   675
      Left            =   240
      ScaleHeight     =   645
      ScaleWidth      =   885
      TabIndex        =   0
      Top             =   5040
      Visible         =   0   'False
      Width           =   915
   End
End
Option Explicit

Sub Form_KeyDown (KeyCode As Integer, Shift As Integer)

'Act on keys we need to monitor
Select Case KeyCode

Case KEY_CUR_LEFT   'Moving left
    giKeyStatus = giKeyStatus Or KEY_CUR_LEFT_FLAG

Case KEY_CUR_RIGHT  'Moving right
    giKeyStatus = giKeyStatus Or KEY_CUR_RIGHT_FLAG

Case KEY_FIRE       'Firing
    giKeyStatus = giKeyStatus Or KEY_FIRE_FLAG

Case KEY_PAUSE      'Pausing the game

Case KEY_ABORT

Case KEY_QUIT       'Quitting the game
    tmrGameLoop.Enabled = False
    frmMain.Hide

End Select


End Sub

Sub Form_KeyUp (KeyCode As Integer, Shift As Integer)

Select Case KeyCode

Case KEY_CUR_LEFT   'Moving left
    giKeyStatus = giKeyStatus And (Not KEY_CUR_LEFT_FLAG)

Case KEY_CUR_RIGHT  'Moving right
    giKeyStatus = giKeyStatus And (Not KEY_CUR_RIGHT_FLAG)

Case KEY_FIRE       'Firing
    giKeyStatus = giKeyStatus And (Not KEY_FIRE_FLAG)

End Select

End Sub

Sub tmrGameLoop_Timer ()

'Restore backgrounds
SprRestore

'Animate sprites
SprAnimAuto

'Check if players bullet hit invader
If iSprCollision(PLAYER_BULLET_ID, INVADER_ID) Then
    SprDeactivateSprite PLAYER_BULLET_ID
    SprDeactivateSprite INVADER_ID
End If

'Check if players bullet is off screen
If gtSpr(PLAYER_BULLET_ID).iActive Then
    If gtSpr(PLAYER_BULLET_ID).iY < 0 Then SprDeactivateSprite PLAYER_BULLET_ID
End If

'Move players sprite if key pressed
If giKeyStatus And KEY_CUR_LEFT_FLAG Then SprMoveSpriteRel PLAYER_ID, -10, 0
If giKeyStatus And KEY_CUR_RIGHT_FLAG Then SprMoveSpriteRel PLAYER_ID, 10, 0

'Move players bullet if active
If gtSpr(PLAYER_BULLET_ID).iActive Then SprMoveSpriteRel PLAYER_BULLET_ID, 0, -10

'Fire a bullet if key pressed and bullet is free
If Not gtSpr(PLAYER_BULLET_ID).iActive Then
    If giKeyStatus And KEY_FIRE_FLAG Then
        SprActivateSprite PLAYER_BULLET_ID, gtSpr(PLAYER_ID).iX + (gtSpr(PLAYER_ID).iW \ 2) - (gtSpr(PLAYER_BULLET_ID).iW \ 2), 160
    End If
End If

'Draw sprites
SprDraw

'Update the display
SprShowPlayDC frmMain.hDC, 10, 10

End Sub

