Option Explicit

Const VBModal = 1

'Define how many sprites are in use
Global Const MAX_SPRITES_USED = 1

'Define the sprite
Global Const LONELY_SPRITE_ID = 0
Global Const LONELY_SPRITE_FRM_FROM = 20
Global Const LONELY_SPRITE_FRM_TO = 21

Sub Main ()

Dim i As Integer
Dim tSpr As SprNewSprite

'Must initialise the array
ReDim gtSpr(1)

'Load the game form
Load frmMain

'Get play area
i = iSprGetPlayDC(frmMain.hDC, 300, 200)

'Load sprite graphics
If i Then
    i = iSprLoadGfx(frmMain.picSpr, "eg.bmp")

    'Load sprite graphic frame data
    If i Then
        i = iSprLoadFrames("frames.mm1")

        'Get a single sprite
        If i Then
            tSpr.iId = LONELY_SPRITE_ID
            tSpr.iFirstFrame = LONELY_SPRITE_FRM_FROM
            tSpr.iLastFrame = LONELY_SPRITE_FRM_TO
            tSpr.iAnimFlag = True
            tSpr.iAnimRate = 4
            i = iSprAllocateSprite(tSpr)

            'Activate the sprite
            If i Then
                SprActivateSprite LONELY_SPRITE_ID, 10, 10

                'Show the form and let play commence!
                frmMain.Show VBModal
            End If
        End If
    End If
End If

'Make sure all resources are released
SprFreeAll

'Trash the form
Unload frmMain

End Sub

